Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.nio.protocol
Class ThrottlingHttpClientHandler

    java.lang.Object
      org.apache.http.nio.protocol.NHttpHandlerBase
          org.apache.http.nio.protocol.ThrottlingHttpClientHandler

All Implemented Interfaces:
  NHttpClientHandler

Deprecated. (4.2) use `HttpAsyncRequestExecutor` and `HttpAsyncRequester`

    @Deprecated
    @Contract(threading=SAFE_CONDITIONAL)
    public class ThrottlingHttpClientHandler

extends NHttpHandlerBase
implements NHttpClientHandler

Client protocol handler implementation that provide compatibility with the blocking I/O by utilizing shared content buffers and a fairly small pool of worker threads. The throttling protocol handler allocates input / output buffers of a constant length upon initialization and controls the rate of I/O events in order to ensure those content buffers do not ever get overflown. This helps ensure nearly constant memory footprint for HTTP connections and avoid the out of memory condition while streaming content in and out. The `HttpRequestExecutionHandler.handleResponse(HttpResponse, HttpContext)` method will fire immediately when a message is received. The protocol handler delegate the task of processing requests and generating response content to an `Executor`, which is expected to perform those tasks using dedicated worker threads in order to avoid blocking the I/O thread.

Usually throttling protocol handlers need only a modest number of worker threads, much fewer than the number of concurrent connections. If the length of the message is smaller or about the size of the shared content buffer worker thread will just store content in the buffer and terminate almost immediately without blocking. The I/O dispatch thread in its turn will take care of sending out the buffered content asynchronously. The worker thread will have to block only when processing large messages and the shared buffer fills up. It is generally advisable to allocate shared buffers of a size of an average content body for optimal performance.

The following parameters can be used to customize the behavior of this class:

- `NIOReactorPNames.CONTENT_BUFFER_SIZE`
- `CoreProtocolPNames.WAIT_FOR_CONTINUE`

Since:
  4.0

Field Summary
`protected HttpRequestExecutionHandler` | `execHandler` Deprecated.
`protected Executor` | `executor` Deprecated.

Fields inherited from class org.apache.http.nio.protocol.NHttpHandlerBase
`allocator, CONN_STATE, connStrategy, eventListener, httpProcessor, params`

Constructor Summary
`ThrottlingHttpClientHandler(HttpProcessor httpProcessor, HttpRequestExecutionHandler execHandler, ConnectionReuseStrategy connStrategy, ByteBufferAllocator allocator, Executor executor, HttpParams params)` Deprecated.
`ThrottlingHttpClientHandler(HttpProcessor httpProcessor, HttpRequestExecutionHandler execHandler, ConnectionReuseStrategy connStrategy, Executor executor, HttpParams params)` Deprecated.

Method Summary
`void` | `closed(NHttpClientConnection conn)` Deprecated. Triggered when the connection is closed.
`void` | `connected(NHttpClientConnection conn, Object attachment)` Deprecated. Triggered when a new outgoing connection is created.
`void` | `exception(NHttpClientConnection conn, HttpException ex)` Deprecated. Triggered when an HTTP protocol violation occurs while receiving an HTTP response.
`void` | `exception(NHttpClientConnection conn, IOException ex)` Deprecated. Triggered when an I/O error occurs while reading from or writing to the underlying channel.
`void` | `inputReady(NHttpClientConnection conn, ContentDecoder decoder)` Deprecated. Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.
`void` | `outputReady(NHttpClientConnection conn, ContentEncoder encoder)` Deprecated. Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.
`void` | `requestReady(NHttpClientConnection conn)` Deprecated. Triggered when the connection is ready to accept a new HTTP request.
`void` | `responseReceived(NHttpClientConnection conn)` Deprecated. Triggered when an HTTP response is received.
`void` | `timeout(NHttpClientConnection conn)` Deprecated. Triggered when no input is detected on this connection over the maximum period of inactivity.

Methods inherited from class org.apache.http.nio.protocol.NHttpHandlerBase
`canResponseHaveBody, closeConnection, getParams, handleTimeout, setEventListener, shutdownConnection`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### execHandler

    protected HttpRequestExecutionHandler execHandler

  Deprecated.

### executor

    protected final Executor executor

  Deprecated.

Constructor Detail

### ThrottlingHttpClientHandler

    public ThrottlingHttpClientHandler(HttpProcessor httpProcessor,
                                       HttpRequestExecutionHandler execHandler,
                                       ConnectionReuseStrategy connStrategy,
                                       ByteBufferAllocator allocator,
                                       Executor executor,
                                       HttpParams params)

  Deprecated.

### ThrottlingHttpClientHandler

    public ThrottlingHttpClientHandler(HttpProcessor httpProcessor,
                                       HttpRequestExecutionHandler execHandler,
                                       ConnectionReuseStrategy connStrategy,
                                       Executor executor,
                                       HttpParams params)

  Deprecated.

Method Detail

### connected

    public void connected(NHttpClientConnection conn,
                          Object attachment)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when a new outgoing connection is created.

  Specified by:
    `connected` in interface `NHttpClientHandler`
  Parameters:
    `conn` - new outgoing HTTP connection.
    `attachment` - an object that was attached to the session request

### closed

    public void closed(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the connection is closed.

  Specified by:
    `closed` in interface `NHttpClientHandler`
  Parameters:
    `conn` - closed HTTP connection.

### exception

    public void exception(NHttpClientConnection conn,
                          HttpException ex)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an HTTP protocol violation occurs while receiving an HTTP response.

  Specified by:
    `exception` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused an HTTP protocol violation
    `ex` - HTTP protocol violation exception

### exception

    public void exception(NHttpClientConnection conn,
                          IOException ex)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an I/O error occurs while reading from or writing to the underlying channel.

  Specified by:
    `exception` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused an I/O error
    `ex` - I/O exception

### requestReady

    public void requestReady(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the connection is ready to accept a new HTTP request. The protocol handler does not have to submit a request if it is not ready.

  Specified by:
    `requestReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that is ready to accept a new HTTP request.
  See Also:
    `NHttpClientConnection`

### outputReady

    public void outputReady(NHttpClientConnection conn,
                            ContentEncoder encoder)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.

  If the content producer is unable to generate the outgoing content, output event notifications can be temporarily suspended using `IOControl` interface.

  Specified by:
    `outputReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that can accommodate a new portion of the outgoing request content.
    `encoder` - The content encoder to use to write content.
  See Also:
    `NHttpClientConnection`, `ContentEncoder`, `IOControl`

### responseReceived

    public void responseReceived(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an HTTP response is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP response object.

  If the response received encloses a response entity this method will be followed by a series of `NHttpClientHandler.inputReady(NHttpClientConnection, ContentDecoder)` calls to transfer the response content.

  Specified by:
    `responseReceived` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that contains an HTTP response
  See Also:
    `NHttpClientConnection`

### inputReady

    public void inputReady(NHttpClientConnection conn,
                           ContentDecoder decoder)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.

  If the content consumer is unable to process the incoming content, input event notifications can be temporarily suspended using `IOControl` interface.

  Specified by:
    `inputReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that can produce a new portion of the incoming response content.
    `decoder` - The content decoder to use to read content.
  See Also:
    `NHttpClientConnection`, `ContentDecoder`, `IOControl`

### timeout

    public void timeout(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when no input is detected on this connection over the maximum period of inactivity.

  Specified by:
    `timeout` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused timeout condition.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.